/* main.c: defines main() for cc1, cc1plus, etc.

This file is part of GCC.

GCC is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

GCC is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "toplev.h"

int main (int argc, char **argv);

/* We define main() to call toplev_main(), which is defined in toplev.c.
   We do this in a separate file in order to allow the language front-end
   to define a different main(), if it so desires.  */

/* TAU */
FILE *pdbfile;
FILE *persistFile;
int tau_so_num = 0;
int tau_ro_num = 0;
int tau_ty_num = 0;
/* TAU */

/* TAU */
/* 
   Notes: This is the main for f951, cc1, xgcc and others

*/
/* TAU */

int
main (int argc, char **argv)
{
  int i;
  /* TAU */
  /*   printf ("main, argc = %d\n", argc); */
  /*   for (i=0; i < argc; i++) { */
  /*     printf ("argv[%d] = %s\n", i, argv[i]); */
  /*   } */
  
  /*   fprintf (stderr, "getppid=%d\n", getppid()); */

  char *pdb_filename;
  /* TAU: We get the routine number and source number from this file */
  char tmpFile[512];
  sprintf (tmpFile, ".gf.%d",getppid());

  persistFile = fopen (tmpFile, "r");
  if (persistFile != NULL) {
    fscanf(persistFile,"%d %d %d", &tau_so_num, &tau_ro_num, &tau_ty_num);
    fclose(persistFile);
  }

  pdb_filename = getenv("GFORTRAN_PDB_FILENAME");
  if (pdb_filename == 0) {
    pdb_filename = "gfortran.pdb";
  }
  remove(pdb_filename);

  pdbfile = fopen (pdb_filename, "r");
  if (pdbfile) {
    fclose(pdbfile);
    pdbfile = fopen (pdb_filename, "a");
  } else {
    /* if there's no persist file, then restart the values */
    tau_so_num = 0;
    tau_ro_num = 0;
    tau_ty_num = 0;

    pdbfile = fopen (pdb_filename, "w");
    if (!pdbfile) {
      fprintf (stderr, "Fatal Error: couldn't write to %s (no write permission?)\n", pdb_filename);
      return -1;
    }
    fprintf (pdbfile, "<PDB 3.0>\nlang fortran\n");
  }


  

  int retval = toplev_main (argc, (const char **) argv);

  fclose (pdbfile);

  tau_so_num++;

  persistFile = fopen (tmpFile, "w");
  if (persistFile != NULL) {
    fprintf(persistFile,"%d %d %d", tau_so_num, tau_ro_num, tau_ty_num);
    fclose(persistFile);
  }


  return retval;

/*   return toplev_main (argc, (const char **) argv); */

}
